# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetOrganizationResult',
    'AwaitableGetOrganizationResult',
    'get_organization',
    'get_organization_output',
]

@pulumi.output_type
class GetOrganizationResult:
    """
    A collection of values returned by getOrganization.
    """
    def __init__(__self__, allowed_api_ip_addresses=None, id=None, uuid=None):
        if allowed_api_ip_addresses and not isinstance(allowed_api_ip_addresses, list):
            raise TypeError("Expected argument 'allowed_api_ip_addresses' to be a list")
        pulumi.set(__self__, "allowed_api_ip_addresses", allowed_api_ip_addresses)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if uuid and not isinstance(uuid, str):
            raise TypeError("Expected argument 'uuid' to be a str")
        pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter(name="allowedApiIpAddresses")
    def allowed_api_ip_addresses(self) -> Optional[Sequence[str]]:
        """
        list of IP addresses in CIDR format that are allowed to access the Buildkite API.
        """
        return pulumi.get(self, "allowed_api_ip_addresses")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def uuid(self) -> str:
        return pulumi.get(self, "uuid")


class AwaitableGetOrganizationResult(GetOrganizationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrganizationResult(
            allowed_api_ip_addresses=self.allowed_api_ip_addresses,
            id=self.id,
            uuid=self.uuid)


def get_organization(allowed_api_ip_addresses: Optional[Sequence[str]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrganizationResult:
    """
    ## # Data Source: organization

    Use this data source to look up the organization settings. It currently supports
    allowed_api_ip_addresses.


    :param Sequence[str] allowed_api_ip_addresses: list of IP addresses in CIDR format that are allowed to access the Buildkite API.
    """
    __args__ = dict()
    __args__['allowedApiIpAddresses'] = allowed_api_ip_addresses
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('buildkite:Organization/getOrganization:getOrganization', __args__, opts=opts, typ=GetOrganizationResult).value

    return AwaitableGetOrganizationResult(
        allowed_api_ip_addresses=__ret__.allowed_api_ip_addresses,
        id=__ret__.id,
        uuid=__ret__.uuid)


@_utilities.lift_output_func(get_organization)
def get_organization_output(allowed_api_ip_addresses: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrganizationResult]:
    """
    ## # Data Source: organization

    Use this data source to look up the organization settings. It currently supports
    allowed_api_ip_addresses.


    :param Sequence[str] allowed_api_ip_addresses: list of IP addresses in CIDR format that are allowed to access the Buildkite API.
    """
    ...
